#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
typedef struct gb2ucs_t {
	unsigned short gb;
	long ucs;
} gb2ucs_t;
typedef struct composite_t {
	unsigned short gb;
	long ucs[2];
} composite_t;
#include "gbk2ucs.h"
#include "gbf2ucs.h"
typedef unsigned short USHORT;
//
//KSR[ȟԂl߂
//߂l: ϊ(0 = ϊs)
//
long pack_gb(const USHORT gb, const gb2ucs_t *gb2ucs, const int table_count)
{
	int h = gb >> 8;
	int l = gb & 0xff;
	int failed = 0;

	int packed = -1;
	if (h == 0) {
		return (l > 0x80) ? 0 : l;
	} else {
		if (h < 0xa1) {
			failed = 1;
		} else if (h <= 0xfe) {
			h = h - 0xa1; // h = 0-93
		} else {
			failed = 3;
		}

		if (l < 0xa1) {
			failed += 20;
		} else if (l <= 0xfe) {
			l = l - 0xa1; // l = 0-93
		} else {
			failed += 30;
		}

		if (failed) {
			fprintf(stderr, "%#xEUC-GB͈̔͊Oł(%d)B\n", gb, failed);
			return -1;
		}

		packed = h * 94 + l;
	}

	if (packed >= table_count) {
		if (packed < 94 * 94) {
			return 0;
		}
		fprintf(stderr, "%d = %#x << 8 | %#x: %#x͕ϊe[ũTCY%d͈̔͊OłB\n", packed, h, l, gb, sizeof(gb2ucs) / sizeof(gb2ucs[0]));
		return -1;
	}
	if (gb != gb2ucs[packed].gb) {
		fprintf(stderr, "%d/%d = %#x << 8 | %#x: %#x != %#x\n", packed, sizeof(gb2ucs) / sizeof(gb2ucs[0]), h, l, gb, gb2ucs[packed].gb);
		return -1;
	}

	return gb2ucs[packed].ucs;
}
long pack_gbk(const gb)
{
	assert(gb < 0xffff);
	return pack_gb(gb, gbk2ucs, sizeof(gbk2ucs) / sizeof(gbk2ucs[0]));
}
long pack_gbf(const gb)
{
	assert(gb < 0xffff);
	return pack_gb(gb, gbf2ucs, sizeof(gbf2ucs) / sizeof(gbf2ucs[0]));
}

#if 0
int composite_cmp(const composite_t *a, const composite_t *b)
{
  if (a->gb < b->gb) {
    return -1;
  } else if (a->gb > b->gb) {
    return 1;
  } else {
    return 0;
  }
}

composite_t *find_composite(const USHORT gb)
{
	composite_t key;
	key.gb = gb;
	return (composite_t *)bsearch(&key, composite, sizeof composite / sizeof composite[0], sizeof composite[0], (int(*)(const void *, const void *))composite_cmp);
}
#endif
