#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
typedef struct kps2ucs_t {
	unsigned short kps;
	long ucs;
} kps2ucs_t;
typedef struct composite_t {
	unsigned short kps;
	long ucs[2];
} composite_t;
#include "kps2ucs.h"
typedef unsigned short USHORT;
//
//KSR[ȟԂl߂
//߂l: ϊ(0 = ϊs)
//
long pack_kps(const kps)
{
	assert(kps <= 0xffff);

	int h = kps >> 8;
	int l = kps & 0xff;
	int failed = 0;

	int packed = -1;
	if (h == 0) {
		return (l > 0x80) ? 0 : l;
	} else {
		if (h < 0xa1) {
			failed = 1;
		} else if (h <= 0xfe) {
			h = h - 0xa1; // h = 0-93
		} else {
			failed = 3;
		}

		if (l < 0xa1) {
			failed += 20;
		} else if (l <= 0xfe) {
			l = l - 0xa1; // l = 0-93
		} else {
			failed += 30;
		}

		if (failed) {
			fprintf(stderr, "%#xWansung͈̔͊Oł(%d)B\n", kps, failed);
			return -1;
		}

		packed = h * 94 + l;
	}

	if (packed >= sizeof(kps2ucs) / sizeof(kps2ucs[0])) {
		if (packed < 94 * 94) {
			return 0;
		}
		fprintf(stderr, "%d = %#x << 8 | %#x: %#x͕ϊe[ũTCY%d͈̔͊OłB\n", packed, h, l, kps, sizeof(kps2ucs) / sizeof(kps2ucs[0]));
		return -1;
	}
	if (kps != kps2ucs[packed].kps) {
		fprintf(stderr, "%d/%d = %#x << 8 | %#x: %#x != %#x\n", packed, sizeof(kps2ucs) / sizeof(kps2ucs[0]), h, l, kps, kps2ucs[packed].kps);
		return -1;
	}

	return kps2ucs[packed].ucs;
}

#if 0
int composite_cmp(const composite_t *a, const composite_t *b)
{
  if (a->kps < b->kps) {
    return -1;
  } else if (a->kps > b->kps) {
    return 1;
  } else {
    return 0;
  }
}

composite_t *find_composite(const USHORT kps)
{
	composite_t key;
	key.kps = kps;
	return (composite_t *)bsearch(&key, composite, sizeof composite / sizeof composite[0], sizeof composite[0], (int(*)(const void *, const void *))composite_cmp);
}
#endif
