// MacBinarywb_
// http://www.lazerware.com/macbinary/macbinary_iii.html
BEGIN_TABLE(macbinary)
TABLE_ENTRY(BYTE, oldVersion)
TABLE_ENTRY(BYTE, filenameLen)
TABLE_ARRAY(CHAR, filename, 63)
TABLE_ENTRY(Tag, fileType)
TABLE_ENTRY(Tag, creator)
TABLE_ENTRY(BYTE, originalFlags)
TABLE_ENTRY(BYTE, zero)
TABLE_ENTRY(SHORT, vertPos)
TABLE_ENTRY(SHORT, horzPos)
TABLE_ENTRY(USHORT, folderID)
TABLE_ENTRY(BYTE, lockFlag)
TABLE_ENTRY(BYTE, zero2)
TABLE_ENTRY(ULONG, dataForkLen)
TABLE_ENTRY(ULONG, rsrcForkLen)
TABLE_ENTRY(ULONG, created)
TABLE_ENTRY(ULONG, modified)
TABLE_ENTRY(USHORT, commentLen)
TABLE_ENTRY(BYTE, finderFlags)
TABLE_ENTRY(Tag, signature)
TABLE_ENTRY(BYTE, script)
TABLE_ENTRY(BYTE, extendedFlags)
TABLE_ARRAY(BYTE, reserved, 8)
TABLE_ENTRY(ULONG, totalLen)
TABLE_ENTRY(USHORT, nextHeaderLen)
TABLE_ENTRY(BYTE, version)
TABLE_ENTRY(BYTE, minVersion)
TABLE_ENTRY(USHORT, crc)
END_TABLE(macbinary)

// \[XtH[Nwb_
// http://developer.apple.com/documentation/mac/MoreToolbox/MoreToolbox-99.html
BEGIN_TABLE(ResourceHeader)
TABLE_ENTRY(ULONG, resDataOffset)
TABLE_ENTRY(ULONG, resMapOffset)
TABLE_ENTRY(ULONG, resDataLen)
TABLE_ENTRY(ULONG, resMapLen)
END_TABLE(ResourceHeader)

// \[X}bvwb_
BEGIN_TABLE(ResourceMapHeader)
TABLE_ENTRY(ULONG, resDataOffset)
TABLE_ENTRY(ULONG, resMapOffset)
TABLE_ENTRY(ULONG, resDataLen)
TABLE_ENTRY(ULONG, resMapLen)
TABLE_ENTRY(ULONG, nextResMap)
TABLE_ENTRY(USHORT, refNumber)
TABLE_ENTRY(USHORT, attributes)
TABLE_ENTRY(USHORT, typeListOffset)
TABLE_ENTRY(USHORT, nameListOffset)
TABLE_ENTRY(USHORT, typeCount_1)
END_TABLE(ResourceMapHeader)

BEGIN_TABLE(ResourceTypeList)
TABLE_ENTRY(Tag, resType)
TABLE_ENTRY(USHORT, resCount)
TABLE_ENTRY(USHORT, refOffset)
END_TABLE(ResourceTypeList)

BEGIN_TABLE(ResourceRefList)
TABLE_ENTRY(USHORT, id)
TABLE_ENTRY(USHORT, nameOffset)
TABLE_ENTRY(ULONG, dataOffset)
TABLE_ENTRY(ULONG, resHandle)
END_TABLE(ResourceRefList)

BEGIN_TABLE(TTCHeader)
TABLE_ENTRY(Tag, TTCTag)
TABLE_ENTRY(ULONG, Version)
TABLE_ENTRY(ULONG, numFonts)
END_TABLE(TTCHeader)

BEGIN_TABLE(offset_table)
TABLE_ENTRY(Fixed, sfnt_version)
TABLE_ENTRY(USHORT, numTables)
TABLE_ENTRY(USHORT, searchRange)
TABLE_ENTRY(USHORT, entrySelector)
TABLE_ENTRY(USHORT, rangeShift)
END_TABLE(offset_table)

BEGIN_TABLE(table_directory)
TABLE_ENTRY(ULONG, tag)
TABLE_ENTRY(ULONG, checkSum)
TABLE_ENTRY(ULONG, offset)
TABLE_ENTRY(ULONG, length)
END_TABLE(table_directory)

BEGIN_TABLE(head_table)
TABLE_ENTRY(Fixed, version)
TABLE_ENTRY(Fixed, fontRevision)
TABLE_ENTRY(ULONG, checkSumAdjustment)
TABLE_ENTRY(ULONG, magicNumber)
TABLE_ENTRY(USHORT, flags)
TABLE_ENTRY(USHORT, unitsPerEm)
TABLE_ENTRY(LONGDATETIME, created)
TABLE_ENTRY(LONGDATETIME, modified)
TABLE_ENTRY(SHORT, xMin)
TABLE_ENTRY(SHORT, yMin)
TABLE_ENTRY(SHORT, xMax)
TABLE_ENTRY(SHORT, yMax)
TABLE_ENTRY(USHORT, macStyle)
TABLE_ENTRY(USHORT, lowestRecPPEM)
TABLE_ENTRY(SHORT, fontDirectionHint)
TABLE_ENTRY(SHORT, indexToLocFormat)
TABLE_ENTRY(SHORT, glyphDataFormat)
END_TABLE(head_table)

BEGIN_TABLE(hhea_table)
TABLE_ENTRY(Fixed, version)
TABLE_ENTRY(FWORD, Ascender)
TABLE_ENTRY(FWORD, Descender)
TABLE_ENTRY(FWORD, LineGap)
TABLE_ENTRY(UFWORD, advanceWidthMax)
TABLE_ENTRY(FWORD, minLeftSideBearing)
TABLE_ENTRY(FWORD, minRightSideBearing)
TABLE_ENTRY(FWORD, xMaxExtent)
TABLE_ENTRY(SHORT, caretSlopeRise)
TABLE_ENTRY(SHORT, caretSlopeRun)
TABLE_ENTRY(SHORT, caretOffset)
TABLE_ENTRY(SHORT, reserved1)
TABLE_ENTRY(SHORT, reserved2)
TABLE_ENTRY(SHORT, reserved3)
TABLE_ENTRY(SHORT, reserved4)
TABLE_ENTRY(SHORT, metricDataFormat)
TABLE_ENTRY(USHORT, numberOfHMetrics)
END_TABLE(hhea_table)

BEGIN_TABLE(maxp_table)
TABLE_ENTRY(Fixed, version)
TABLE_ENTRY(USHORT, numGlyphs)
TABLE_VERSION(0x00005000)
TABLE_ENTRY(USHORT, maxPoints)
TABLE_ENTRY(USHORT, maxContours)
TABLE_ENTRY(USHORT, maxCompositePoints)
TABLE_ENTRY(USHORT, maxCompositeContours)
TABLE_ENTRY(USHORT, maxZones)
TABLE_ENTRY(USHORT, maxTwilightPoints)
TABLE_ENTRY(USHORT, maxStorage)
TABLE_ENTRY(USHORT, maxFunctionDefs)
TABLE_ENTRY(USHORT, maxInstructionDefs)
TABLE_ENTRY(USHORT, maxStackElements)
TABLE_ENTRY(USHORT, maxSizeOfInstructions)
TABLE_ENTRY(USHORT, maxComponentElements)
TABLE_ENTRY(USHORT, maxComponentDepth)
END_TABLE(maxp_table)

BEGIN_TABLE(OS_2_table)
TABLE_ENTRY(USHORT, version)
TABLE_ENTRY(SHORT, xAvgCharWidth)
TABLE_ENTRY(USHORT, usWeightClass)
TABLE_ENTRY(USHORT, usWidthClass)
TABLE_ENTRY(USHORT, fsType)
TABLE_ENTRY(SHORT, ySubscriptXSize)
TABLE_ENTRY(SHORT, ySubscriptYSize)
TABLE_ENTRY(SHORT, ySubscriptXOffset)
TABLE_ENTRY(SHORT, ySubscriptYOffset)
TABLE_ENTRY(SHORT, ySuperscriptXSize)
TABLE_ENTRY(SHORT, ySuperscriptYSize)
TABLE_ENTRY(SHORT, ySuperscriptXOffset)
TABLE_ENTRY(SHORT, ySuperscriptYOffset)
TABLE_ENTRY(SHORT, yStrikeoutSize)
TABLE_ENTRY(SHORT, yStrikeoutPosition)
TABLE_ENTRY(SHORT, sFamilyClass)
TABLE_ARRAY(BYTE, panose, 10)
TABLE_ENTRY(ULONG, ulUnicodeRange1)
TABLE_ENTRY(ULONG, ulUnicodeRange2)
TABLE_ENTRY(ULONG, ulUnicodeRange3)
TABLE_ENTRY(ULONG, ulUnicodeRange4)
TABLE_ARRAY(CHAR, achVendID, 4)
TABLE_ENTRY(USHORT, fsSelection)
TABLE_ENTRY(USHORT, usFirstCharIndex)
TABLE_ENTRY(USHORT, usLastCharIndex)
TABLE_ENTRY(SHORT, sTypoAscender)
TABLE_ENTRY(SHORT, sTypoDescender)
TABLE_ENTRY(SHORT, sTypoLineGap)
TABLE_ENTRY(USHORT, usWinAscent)
TABLE_ENTRY(USHORT, usWinDescent)
TABLE_VERSION(0)
TABLE_ENTRY(ULONG, ulCodePageRange1)
TABLE_ENTRY(ULONG, ulCodePageRange2)
TABLE_VERSION(1)
TABLE_ENTRY(SHORT, sxHeight)
TABLE_ENTRY(SHORT, sCapHeight)
TABLE_ENTRY(USHORT, usDefaultChar)
TABLE_ENTRY(USHORT, usBreakChar)
TABLE_ENTRY(USHORT, usMaxContext)
END_TABLE(OS_2_table)

BEGIN_TABLE(longHorMetric)
TABLE_ENTRY(USHORT, advanceWidth)
TABLE_ENTRY(SHORT, lsb)
END_TABLE(longHorMetric)

BEGIN_TABLE(vhea_table)
TABLE_ENTRY(Fixed, version)
TABLE_ENTRY(SHORT, ascent)
TABLE_ENTRY(SHORT, descent)
TABLE_ENTRY(SHORT, lineGap)
TABLE_ENTRY(SHORT, advanceHeightMax)
TABLE_ENTRY(SHORT, minTopSideBearing)
TABLE_ENTRY(SHORT, minBottomSideBearing)
TABLE_ENTRY(SHORT, yMaxExtent)
TABLE_ENTRY(SHORT, caretSlopeRise)
TABLE_ENTRY(SHORT, caretSlopeRun)
TABLE_ENTRY(SHORT, caretOffset)
TABLE_ENTRY(SHORT, reserved1)
TABLE_ENTRY(SHORT, reserved2)
TABLE_ENTRY(SHORT, reserved3)
TABLE_ENTRY(SHORT, reserved4)
TABLE_ENTRY(SHORT, metricDataFormat)
TABLE_ENTRY(USHORT, numOfLongVerMetrics)
END_TABLE(vhea_table)

BEGIN_TABLE(longVerMetric)
TABLE_ENTRY(USHORT, advanceHeight)
TABLE_ENTRY(SHORT, topSideBearing)
END_TABLE(longVerMetric)

BEGIN_TABLE(cmap_header)
TABLE_ENTRY(USHORT, version)
TABLE_ENTRY(USHORT, numTables)
END_TABLE(cmap_header)

BEGIN_TABLE(cmap_encoding)
TABLE_ENTRY(USHORT, platformID)
TABLE_ENTRY(USHORT, encodingID)
TABLE_ENTRY(ULONG, offset)
END_TABLE(cmap_encoding)

BEGIN_TABLE(cmap_subtable2)
TABLE_ENTRY(USHORT, format)
TABLE_ENTRY(USHORT, length)
TABLE_ENTRY(USHORT, language)
END_TABLE(cmap_subtable2)

BEGIN_TABLE(cmap_subtable4)
TABLE_ENTRY(USHORT, format)
TABLE_ENTRY(USHORT, length)
TABLE_ENTRY(USHORT, language)
TABLE_ENTRY(USHORT, segCountX2)
TABLE_ENTRY(USHORT, searchRange)
TABLE_ENTRY(USHORT, entrySelector)
TABLE_ENTRY(USHORT, rangeShift)
END_TABLE(cmap_subtable4)

BEGIN_TABLE(cmap_subtable12)
TABLE_ENTRY(USHORT, format)
TABLE_ENTRY(USHORT, reserved)
TABLE_ENTRY(ULONG, length)
TABLE_ENTRY(ULONG, language)
TABLE_ENTRY(ULONG, nGroups)
END_TABLE(cmap_subtable12)

BEGIN_TABLE(cmap_subtable14)
TABLE_ENTRY(USHORT, format)
TABLE_ENTRY(ULONG, length)
TABLE_ENTRY(ULONG, numVarSelectorRecords)
END_TABLE(cmap_subtable14)

BEGIN_TABLE(VarSelectorRecord)
TABLE_ENTRY(UINT24, varSelector)
TABLE_ENTRY(ULONG, defaultUVSOffset)
TABLE_ENTRY(ULONG, nonDefaultUVSOffset)
END_TABLE(VarSelectorRecord)

BEGIN_TABLE(DefaultUVS_header)
TABLE_ENTRY(ULONG, numUnicodeValueRanges)
END_TABLE(DefaultUVS_header)

BEGIN_TABLE(UnicodeValueRange)
TABLE_ENTRY(UINT24, startUnicodeValue)
TABLE_ENTRY(BYTE, additionalCount)
END_TABLE(UnicodeValueRange)

BEGIN_TABLE(NonDefaultUVS_header)
TABLE_ENTRY(ULONG, numUVSMappings)
END_TABLE(NonDefaultUVS_header)

BEGIN_TABLE(UVSMapping)
TABLE_ENTRY(UINT24, unicodeValue)
TABLE_ENTRY(USHORT, glyphID)
END_TABLE(UVSMapping)

BEGIN_TABLE(name_header)
TABLE_ENTRY(USHORT, format)
TABLE_ENTRY(USHORT, count)
TABLE_ENTRY(USHORT, stringOffset)
END_TABLE(name_header)

BEGIN_TABLE(name_record)
TABLE_ENTRY(USHORT, platformID)
TABLE_ENTRY(USHORT, encodingID)
TABLE_ENTRY(USHORT, languageID)
TABLE_ENTRY(USHORT, nameID)
TABLE_ENTRY(USHORT, length)
TABLE_ENTRY(USHORT, offset)
END_TABLE(name_record)

BEGIN_TABLE(glyf_header)
TABLE_ENTRY(SHORT, numberOfContours)
TABLE_ENTRY(SHORT, xMin)
TABLE_ENTRY(SHORT, yMin)
TABLE_ENTRY(SHORT, xMax)
TABLE_ENTRY(SHORT, yMax)
END_TABLE(glyf_header)

BEGIN_TABLE(GSUB_header)
TABLE_ENTRY(Fixed, Version)
TABLE_ENTRY(Offset, ScriptList)
TABLE_ENTRY(Offset, FeatureList)
TABLE_ENTRY(Offset, LookupList)
END_TABLE(GSUB_header)

BEGIN_TABLE(SingleSubst2)
TABLE_ENTRY(uint16, SubstFormat)
TABLE_ENTRY(Offset, Coverage)
TABLE_ENTRY(uint16, GlyphCount)
END_TABLE(SingleSubst2)

BEGIN_TABLE(LigSubst1)
TABLE_ENTRY(uint16, SubstFormat)
TABLE_ENTRY(Offset, Coverage)
TABLE_ENTRY(uint16, LigSetCount)
END_TABLE(LigSubst1)

BEGIN_TABLE(Coverage1)
TABLE_ENTRY(uint16, CoverageFormat)
TABLE_ENTRY(uint16, GlyphCount)
END_TABLE(Coverage1)

BEGIN_TABLE(LigatureSet)
TABLE_ENTRY(uint16, LigatureCount)
END_TABLE(LigatureSet)

BEGIN_TABLE(Ligature)
TABLE_ENTRY(GlyphID, LigGlyph)
TABLE_ENTRY(uint16, CompCount)
END_TABLE(Ligature)

BEGIN_TABLE(LookupList)
TABLE_ENTRY(uint16, LookupCount)
END_TABLE(LookupList)

BEGIN_TABLE(Lookup)
TABLE_ENTRY(uint16, LookupType)
TABLE_ENTRY(uint16, LookupFlag)
TABLE_ENTRY(uint16, SubTableCount)
TABLE_VARARRAY(Offset, SubTable, SubTableCount)
END_TABLE(Lookup)

BEGIN_TABLE(FeatureList)
TABLE_ENTRY(uint16, FeatureCount)
END_TABLE(FeatureList)

BEGIN_TABLE(FeatureRec)
TABLE_ENTRY(Tag, FeatureTag)
TABLE_ENTRY(Offset, Feature)
END_TABLE(FeatureRec)

BEGIN_TABLE(Feature)
TABLE_ENTRY(Offset, FeatureParams)
TABLE_ENTRY(uint16, LookupCount)
TABLE_VARARRAY(uint16, LookupListIndex, LookupCount)
END_TABLE(Feature)

BEGIN_TABLE(ScriptList)
TABLE_ENTRY(uint16, ScriptCount)
END_TABLE(ScriptList)

BEGIN_TABLE(ScriptRec)
TABLE_ENTRY(Tag, ScriptTag)
TABLE_ENTRY(Offset, Script)
END_TABLE(ScriptRec)

BEGIN_TABLE(Script)
TABLE_ENTRY(Offset, DefaultLangSys)
TABLE_ENTRY(uint16, LangSysCount)
END_TABLE(Script)

BEGIN_TABLE(LangSysRecord)
TABLE_ENTRY(Tag, LangSysTag)
TABLE_ENTRY(Offset, LangSys)
END_TABLE(LangSysRecord)

BEGIN_TABLE(LangSys)
TABLE_ENTRY(Offset, LookupOrder)
TABLE_ENTRY(uint16, ReqFeatureIndex)
TABLE_ENTRY(uint16, FeatureCount)
TABLE_VARARRAY(uint16, FeatureIndex, FeatureCount)
END_TABLE(LangSys)

#undef BEGIN_TABLE
#undef TABLE_VERSION
#undef TABLE_ENTRY
#undef TABLE_ARRAY
#undef TABLE_VARARRAY
#undef END_TABLE
