typedef struct unirange_t {
	long start;
	long end;
	int bit;
} unirange_t;
unirange_t unirange[] = {
{ 0x0000, 0x007F, 0 }, // Basic Latin
{ 0x0080, 0x00FF, 1 }, // Latin-1 Supplement
{ 0x0100, 0x017F, 2 }, // Latin Extended-A
{ 0x0180, 0x024F, 3 }, // Latin Extended-B
{ 0x0250, 0x02AF, 4 }, // IPA Extensions
{ 0x02B0, 0x02FF, 5 }, // Spacing Modifier Letters
{ 0x0300, 0x036F, 6 }, // Combining Diacritical Marks
{ 0x0370, 0x03FF, 7 }, // Greek and Coptic
{ 0x0400, 0x04FF, 9 }, // Cyrillic
{ 0x0500, 0x052F, 9 }, // Cyrillic Supplementary
{ 0x0530, 0x058F, 10 }, // Armenian
{ 0x0590, 0x05FF, 11 }, // Hebrew
{ 0x0600, 0x06FF, 13 }, // Arabic
{ 0x0700, 0x074F, 71 }, // Syriac
{ 0x0780, 0x07BF, 72 }, // Thaana
{ 0x0900, 0x097F, 15 }, // Devanagari
{ 0x0980, 0x09FF, 16 }, // Bengali
{ 0x0A00, 0x0A7F, 17 }, // Gurmukhi
{ 0x0A80, 0x0AFF, 18 }, // Gujarati
{ 0x0B00, 0x0B7F, 19 }, // Oriya
{ 0x0B80, 0x0BFF, 20 }, // Tamil
{ 0x0C00, 0x0C7F, 21 }, // Telugu
{ 0x0C80, 0x0CFF, 22 }, // Kannada
{ 0x0D00, 0x0D7F, 23 }, // Malayalam
{ 0x0D80, 0x0DFF, 73 }, // Sinhala
{ 0x0E00, 0x0E7F, 24 }, // Thai
{ 0x0E80, 0x0EFF, 25 }, // Lao
{ 0x0F00, 0x0FFF, 70 }, // Tibetan
{ 0x1000, 0x109F, 74 }, // Myanmar
{ 0x10A0, 0x10FF, 26 }, // Georgian
{ 0x1100, 0x11FF, 28 }, // Hangul Jamo
{ 0x1200, 0x137F, 75 }, // Ethiopic
{ 0x13A0, 0x13FF, 76 }, // Cherokee
{ 0x1400, 0x167F, 77 }, // Unified Canadian Aboriginal Syllabics
{ 0x1680, 0x169F, 78 }, // Ogham
{ 0x16A0, 0x16FF, 79 }, // Runic
{ 0x1700, 0x171F, 84 }, // Tagalog
{ 0x1720, 0x173F, 84 }, // Hanunoo
{ 0x1740, 0x175F, 84 }, // Buhid
{ 0x1760, 0x177F, 84 }, // Tagbanwa
{ 0x1780, 0x17FF, 80 }, // Khmer
{ 0x1800, 0x18AF, 81 }, // Mongolian
//{ 0x1900, 0x194F,  }, // Limbu
//{ 0x1950, 0x197F,  }, // Tai Le
{ 0x19E0, 0x19FF, 80 }, // Khmer Symbols
//{ 0x1D00, 0x1D7F,  }, // Phonetic Extensions
{ 0x1E00, 0x1EFF, 29 }, // Latin Extended Additional
{ 0x1F00, 0x1FFF, 30 }, // Greek Extended
{ 0x2000, 0x206F, 31 }, // General Punctuation
{ 0x2070, 0x209F, 32 }, // Superscripts and Subscripts
{ 0x20A0, 0x20CF, 33 }, // Currency Symbols
{ 0x20D0, 0x20FF, 34 }, // Combining Diacritical Marks for Symbols
{ 0x2100, 0x214F, 35 }, // Letterlike Symbols
{ 0x2150, 0x218F, 36 }, // Number Forms
{ 0x2190, 0x21FF, 37 }, // Arrows
{ 0x2200, 0x22FF, 38 }, // Mathematical Operators
{ 0x2300, 0x23FF, 39 }, // Miscellaneous Technical
{ 0x2400, 0x243F, 40 }, // Control Pictures
{ 0x2440, 0x245F, 41 }, // Optical Character Recognition
{ 0x2460, 0x24FF, 42 }, // Enclosed Alphanumerics
{ 0x2500, 0x257F, 43 }, // Box Drawing
{ 0x2580, 0x259F, 44 }, // Block Elements
{ 0x25A0, 0x25FF, 45 }, // Geometric Shapes
{ 0x2600, 0x26FF, 46 }, // Miscellaneous Symbols
{ 0x2700, 0x27BF, 47 }, // Dingbats
{ 0x27C0, 0x27EF, 38 }, // Miscellaneous Mathematical Symbols-A
{ 0x27F0, 0x27FF, 37 }, // Supplemental Arrows-A
{ 0x2800, 0x28FF, 82 }, // Braille Patterns
{ 0x2900, 0x297F, 37 }, // Supplemental Arrows-B
{ 0x2980, 0x29FF, 38 }, // Miscellaneous Mathematical Symbols-B
{ 0x2A00, 0x2AFF, 38 }, // Supplemental Mathematical Operators
{ 0x2B00, 0x2BFF, 37 }, // Miscellaneous Symbols and Arrows
//{ 0x2B00, 0x2BFF, 46 }, // Miscellaneous Symbols and Arrows
{ 0x2E80, 0x2EFF, 59 }, // CJK Radicals Supplement
{ 0x2F00, 0x2FDF, 59 }, // Kangxi Radicals
{ 0x2FF0, 0x2FFF, 59 }, // Ideographic Description Characters
{ 0x3000, 0x303F, 48 }, // CJK Symbols and Punctuation
{ 0x3040, 0x309F, 49 }, // Hiragana
{ 0x30A0, 0x30FF, 50 }, // Katakana
{ 0x3100, 0x312F, 51 }, // Bopomofo
{ 0x3130, 0x318F, 52 }, // Hangul Compatibility Jamo
{ 0x3190, 0x319F, 59 }, // Kanbun
{ 0x31A0, 0x31BF, 51 }, // Bopomofo Extended
{ 0x31F0, 0x31FF, 50 }, // Katakana Phonetic Extensions
{ 0x3200, 0x32FF, 54 }, // Enclosed CJK Letters and Months
{ 0x3300, 0x33FF, 55 }, // CJK Compatibility
{ 0x3400, 0x4DBF, 59 }, // CJK Unified Ideographs Extension A
//{ 0x4DC0, 0x4DFF,  }, // Yijing Hexagram Symbols
{ 0x4E00, 0x9FFF, 59 }, // CJK Unified Ideographs
{ 0xA000, 0xA48F, 83 }, // Yi Syllables
{ 0xA490, 0xA4CF, 83 }, // Yi Radicals
{ 0xAC00, 0xD7AF, 56 }, // Hangul Syllables
//{ 0xD800, 0xDB7F,  }, // High Surrogates
//{ 0xDB80, 0xDBFF,  }, // High Private Use Surrogates
//{ 0xDC00, 0xDFFF,  }, // Low Surrogates
{ 0xE000, 0xF8FF, 60 }, // Private Use Area
{ 0xF900, 0xFAFF, 61 }, // CJK Compatibility Ideographs
{ 0xFB00, 0xFB4F, 62 }, // Alphabetic Presentation Forms
{ 0xFB50, 0xFDFF, 63 }, // Arabic Presentation Forms-A
{ 0xFE00, 0xFE0F, 91 }, // Variation Selectors
{ 0xFE20, 0xFE2F, 64 }, // Combining Half Marks
{ 0xFE30, 0xFE4F, 65 }, // CJK Compatibility Forms
{ 0xFE50, 0xFE6F, 66 }, // Small Form Variants
{ 0xFE70, 0xFEFF, 67 }, // Arabic Presentation Forms-B
{ 0xFF00, 0xFFEF, 68 }, // Halfwidth and Fullwidth Forms
{ 0xFFF0, 0xFFFF, 69 }, // Specials
//{ 0x10000, 0x1007F,  }, // Linear B Syllabary
//{ 0x10080, 0x100FF,  }, // Linear B Ideograms
//{ 0x10100, 0x1013F,  }, // Aegean Numbers
{ 0x10300, 0x1032F, 85 }, // Old Italic
{ 0x10330, 0x1034F, 86 }, // Gothic
//{ 0x10380, 0x1039F,  }, // Ugaritic
{ 0x10400, 0x1044F, 87 }, // Deseret
//{ 0x10450, 0x1047F,  }, // Shavian
//{ 0x10480, 0x104AF,  }, // Osmanya
//{ 0x10800, 0x1083F,  }, // Cypriot Syllabary
{ 0x1D000, 0x1D0FF, 88 }, // Byzantine Musical Symbols
{ 0x1D100, 0x1D1FF, 88 }, // Musical Symbols
//{ 0x1D300, 0x1D35F,  }, // Tai Xuan Jing Symbols
{ 0x1D400, 0x1D7FF, 89 }, // Mathematical Alphanumeric Symbols
{ 0x20000, 0x2A6DF, 59 }, // CJK Unified Ideographs Extension B
{ 0x2F800, 0x2FA1F, 61 }, // CJK Compatibility Ideographs Supplement
{ 0xE0000, 0xE007F, 92 }, // Tags
{ 0xE0100, 0xE01EF, 91 }, // Variation Selectors Supplement
{ 0xF0000, 0xFFFFF, 90 }, // Supplementary Private Use Area-A
{ 0x100000, 0x10FFFF, 90 }, // Supplementary Private Use Area-B
};
